/*
 * File:    fe_1.S
 * Author:  Gesine Hinterwlder
 *          modifications for gcc by Peter Schwabe
 * Public Domain
 */
 
#include "msp430fr5969.h"

.global fe_1
.type fe_1, @function

#ifdef TACCTL2_
  #define CCTLX TACCTL2
  #define CCRX TACCR2
#else
  #define CCTLX TACCTL0
  #define CCRX TACCR0
#endif

fe_1:
  
  mov.w   #1,0(R15)
  clr.w   2(R15)
  clr.w   4(R15)
  clr.w   6(R15)
  clr.w   8(R15)
  clr.w   10(R15)
  clr.w   12(R15)
  clr.w   14(R15)
  clr.w   16(R15)
  clr.w   18(R15)
  clr.w   20(R15)
  clr.w   22(R15)
  clr.w   24(R15)
  clr.w   26(R15)
  clr.w   28(R15)
  clr.w   30(R15)

ret
