/*
 * File:    fe_copy.S
 * Author:  Gesine Hinterwlder
 *          modifications for gcc by Peter Schwabe
 * Public Domain
 */
 
#include "msp430fr5969.h"

.global fe_copy
.type fe_copy, @function

    
    
#ifdef TACCTL2_
  #define CCTLX TACCTL2
  #define CCRX TACCR2
#else
  #define CCTLX TACCTL0
  #define CCRX TACCR0
#endif


fe_copy:

  mov.w   @R14+,0(R15)
  mov.w   @R14+,2(R15)
  mov.w   @R14+,4(R15)
  mov.w   @R14+,6(R15)
  mov.w   @R14+,8(R15)
  mov.w   @R14+,10(R15)
  mov.w   @R14+,12(R15)
  mov.w   @R14+,14(R15)
  mov.w   @R14+,16(R15)
  mov.w   @R14+,18(R15)
  mov.w   @R14+,20(R15)
  mov.w   @R14+,22(R15)
  mov.w   @R14+,24(R15)
  mov.w   @R14+,26(R15)
  mov.w   @R14+,28(R15)
  mov.w   @R14,30(R15)

  ret
